﻿using System;

namespace Petzold.Epub.Common
{
    // TODO: Wouldn't it be simpler to just make this a struct?

    public class PageParams : IEquatable<PageParams>
    {
        public PageParams()
        {
            this.Zoom = 1;
        }

        public Dimension PageSize { set; get; }

        public string DefaultFontFamily { set; get; }

        public double DefaultFontSize { set; get; }

        public double Zoom { set; get; }

        public bool Equals(PageParams that)
        {
            bool equals = this.PageSize.Equals(that.PageSize) &&
                   ((String.IsNullOrEmpty(this.DefaultFontFamily) && String.IsNullOrEmpty(that.DefaultFontFamily)) || this.DefaultFontFamily.Equals(that.DefaultFontFamily)) &&
                   this.DefaultFontSize.Equals(that.DefaultFontSize) &&
                   this.Zoom.Equals(that.Zoom);

            return equals;
        }

        public override bool Equals(object obj)
        {
            if (!(obj is bool))
                return false;

            return this.Equals((bool)obj);
        }

        public override int GetHashCode()
        {
            return (int)(this.PageSize.Width * this.PageSize.Height);
        }
    }
}
