﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Petzold.Epub.Common
{
    public class PageStart
    {
        public PageStart() : this(new int[0], 0, 0)
        {
        }

        public PageStart(int[] elementIndices, int textIndex, int characterOffset) : 
            this(new List<int>(elementIndices), textIndex, characterOffset)
        {
        }

        public PageStart(IList<int> elementIndices, int textIndex, int characterOffset)
        {
            this.ElementIndices = elementIndices;
            this.TextIndex = textIndex;
            this.CharacterOffset = characterOffset;
        }

        public IList<int> ElementIndices { protected set; get; }

        public int TextIndex { protected set; get; }

        public int CharacterOffset { protected set; get; }

        public bool IsLastPage { set; get; }

        public override string ToString()
        {
            string str = "{";

            for (int i = 0; i < this.ElementIndices.Count; i++)
            {
                str += this.ElementIndices[i].ToString();

                if (i != this.ElementIndices.Count - 1)
                    str += " ";
            }

            str += "}" + String.Format(",{0},{1},{2}", this.TextIndex, this.CharacterOffset, this.IsLastPage);
            
            return str;
        }
    }
}
