﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Petzold.Epub.Common
{
    public struct RgbColor
    {
        public RgbColor(byte r, byte g, byte b) : this()
        {
            this.R = r;
            this.G = g;
            this.B = b;
        }

        public RgbColor(string clr) : this()
        {
            switch (clr)
            {
                case "black":
                    Clone(RgbColor.Black);
                    break;
                    
                case "white":
                    Clone(RgbColor.White);
                    break;
            }
        }

        public byte R { set; get; }

        public byte G { set; get; }

        public byte B { set; get; }

        public static RgbColor Black { get { return new RgbColor(0, 0, 0); } }

        public static RgbColor White { get { return new RgbColor(255, 255, 255); } }

        private void Clone(RgbColor rgb)
        {
            this.R = rgb.R;
            this.G = rgb.G;
            this.B = rgb.B;
        }
    }
}
