﻿using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace Petzold.Epub.Viewer.Windows8
{
    // TODO: Change back to abstract when Windows 8 allows DPs to be defined in abstract classes
    public /* abstract */ class PageTransition : DependencyObject
    {
        public static readonly DependencyProperty FractionalBaseIndexProperty =
            DependencyProperty.Register("FractionalBaseIndex",
                "Double",
                typeof(PageTransition).FullName,
                new PropertyMetadata((double)-1, OnTransitionChanged));

        public double FractionalBaseIndex
        {
            set { SetValue(FractionalBaseIndexProperty, value); }
            get { return (double)GetValue(FractionalBaseIndexProperty); }
        }

        public virtual double AnimationDuration 
        {
            get { return 1000; }
        }

        static void OnTransitionChanged(DependencyObject obj, 
                                        DependencyPropertyChangedEventArgs args)
        {
            (obj as PageTransition).OnTransitionChanged(args);
        }

        void OnTransitionChanged(DependencyPropertyChangedEventArgs args)
        {
            double fraction = (3 + this.FractionalBaseIndex) % 1;
            int baseIndex = (int)(3 + this.FractionalBaseIndex - fraction) % 3;
            ShowPageTransition(baseIndex, fraction);
        }

        public /* abstract */ virtual void Attach(Panel containerPanel,
                                    FrameworkElement pageContainer0,
                                    FrameworkElement pageContainer1,
                                    FrameworkElement pageContainer2) {}

        public /* abstract */ virtual void Detach() {}

        protected /* abstract */ virtual void ShowPageTransition(int baseIndex, double fraction) { System.Diagnostics.Debug.WriteLine("PageTransition.ShowPageTransition {0} {1}", baseIndex, fraction); }
    }
}
