﻿using System;
using opf = Petzold.Epub.Package.OpfPackageDocument;

namespace Petzold.Epub
{
    public class BookInformation
    {
        public BookInformation(opf.metadata metadata)
        {
            this.Titles = new string[metadata.title.Length];
            Array.Copy(metadata.title, this.Titles, this.Titles.Length);

            if (metadata.creators != null && metadata.creators.Length > 0)
            {
                this.Creators = new Creator[metadata.creators.Length];
                for (int i = 0; i < this.Creators.Length; i++)
                    this.Creators[i] = new Creator(metadata.creators[i].name,
                                                   metadata.creators[i].role);
            }

            if (metadata.contributors != null && metadata.contributors.Length > 0)
            {
                this.Contributors = new Creator[metadata.contributors.Length];
                for (int i = 0; i < this.Contributors.Length; i++)
                    this.Contributors[i] = new Creator(metadata.contributors[i].name,
                                                       metadata.contributors[i].role);
            }

            if (metadata.dates != null && metadata.dates.Length > 0)
            {
                this.Dates = new EpubDate[metadata.dates.Length];
                for (int i = 0; i < this.Dates.Length; i++)
                    this.Dates[i] = new EpubDate(metadata.dates[i].value,
                                             metadata.dates[i].evt);
            }

            this.Publisher = metadata.publisher;
        }

        public string[] Titles { protected set;  get; }

        public Creator[] Creators { protected set; get; }

        public Creator[] Contributors { protected set; get; }

        public string Publisher { protected set; get; }

        public EpubDate[] Dates { protected set; get; }
    }
}
