﻿using System;

namespace Petzold.Epub
{
    public class EpubDate
    {
        // TODO: Sometimes a data is incorrectly "NONE", so need a way to return an invalid data to BookInformation so not added to collection

        public EpubDate(string date, string evt)
        {
            int year;
            if (!Int32.TryParse(date.Substring(0, 4), out year))
                year = 2000;

            int month = 1;
            int index = date.IndexOf('-') + 1;
            if (index != 0)
                if (!Int32.TryParse(date.Substring(index, 2), out month))
                    month = 1;

            int day = 1;
            index = date.IndexOf('-', index) + 1;
            if (index != 0)
                if (!Int32.TryParse(date.Substring(index, 2), out day))
                    day = 1;

            this.Date = new DateTime(year, month, day);
            this.Event = evt;
        }

        public DateTime Date { set; get; }

        public string Event { set; get; }
    }
}
