﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Xml.Serialization;

namespace Petzold.Epub.Package.EpubContainerFile
{
    [XmlRoot(Namespace="urn:oasis:names:tc:opendocument:xmlns:container")]
    public class container
    {
        public static container Deserialize(Stream stream)
        {
            XmlSerializer serializer = new XmlSerializer(typeof(container));
            return serializer.Deserialize(stream) as container;
        }

        [XmlAttribute]
        public string version { set; get; }

        [XmlNamespaceDeclarations]
        public XmlSerializerNamespaces xmlns { set; get; }

        public rootfiles rootfiles { set; get; }       
    }

    public class rootfiles
    {
        [XmlElement("rootfile")]
        public List<rootfile> rootFileArray { set; get; }

        public rootfile this[int index]
        {
            get { return rootFileArray[index]; }
        }
    }

    public class rootfile
    {
        [XmlAttribute("media-type")]
        public string mediatype { set; get; }

        [XmlAttribute("full-path")]
        public string fullpath { set; get; }
    }
}
