﻿using System.IO;
using System.Xml;
using System.Xml.Serialization;

namespace Petzold.Epub.Package.NcxNavigationDocument
{
    [XmlRoot(Namespace="http://www.daisy.org/z3986/2005/ncx/")]
    public class ncx
    {
        public static ncx Deserialize(Stream stream)
        {
            XmlSerializer serializer = new XmlSerializer(typeof(ncx));

            XmlReaderSettings readerSettings = new XmlReaderSettings
            {
                DtdProcessing = DtdProcessing.Ignore
            };

            XmlReader xmlReader = XmlReader.Create(stream, readerSettings);

            return serializer.Deserialize(xmlReader) as ncx;
        }

  //      [XmlNamespaceDeclarations]
  //      public XmlSerializerNamespaces xmlns { set; get; }

        [XmlAttribute]
        public string version { set; get; }

        [XmlAttribute]
        public string lang { set; get; }

        public head head { set; get; }

        public docTitle docTitle { set; get; }

        public docAuthor docAuthor { set; get; }

        public navMap navMap { set; get; }
    }

    public class head
    {
        [XmlElement(ElementName="meta")]
        public meta[] meta { set; get; }
    }

    public class meta
    {
        [XmlAttribute]
        public string name;

        [XmlAttribute]
        public string content;
    }

    public class docTitle
    {
        public string text { set; get; }
    }

    public class docAuthor
    {
        public string text { set; get; }
    }

    public class navMap
    {
        [XmlElement(ElementName="navPoint")]
        public navPoint[] navPoints { set; get; }
    }

    public class navPoint
    {
        [XmlAttribute]
        public string id { set; get; }

        [XmlAttribute]
        public int playOrder { set; get; }

        public navLabel navLabel { set; get; }

        public content content { set; get; }

        [XmlElement(ElementName = "navPoint")]
        public navPoint[] navPoints { set; get; }
    }

    public class navLabel
    {
        public string text { set; get; }
    }

    public class content
    {
        [XmlAttribute]
        public string src { set; get; }
    }

    public class pageList
    {

    }

    public class pageTarget
    {

    }

    public class navList
    {

    }
}
