﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using nav = Petzold.Epub.Package.NcxNavigationDocument;

namespace Petzold.Epub
{
    public class TableOfContents
    {
        public TableOfContents(nav.navMap navMap)
        {
            this.Chapters = new List<ChapterReference>();
            AddToContents(navMap.navPoints, 0);
        }

        public IList<ChapterReference> Chapters { protected set; get; }

        void AddToContents(nav.navPoint[] navPoints, int level)
        {
            foreach (nav.navPoint navPoint in navPoints)
            {
                ChapterReference chapter = new ChapterReference
                {
                    Title = navPoint.navLabel.text,
                    Source = navPoint.content.src,
                    Level = level
                };

                this.Chapters.Add(chapter);

                if (navPoint.navPoints != null && navPoint.navPoints.Length > 0)
                {
                    AddToContents(navPoint.navPoints, level + 1);
                }
            }
        }
    }
}
