using System;
using System.Threading.Tasks;
using Windows.ApplicationModel.Activation;
using Windows.UI.Xaml;

namespace TheNewEpublic
{
    partial class App
    {
        public AppSettings AppSettings { set; get; }


        public App()
        {
            InitializeComponent();

            App.Current.UnhandledException += (sender, args) =>
                {
                    System.Diagnostics.Debug.WriteLine(args.Exception.ToString());
                    args.Handled = true;
                };
        }

        protected override void OnLaunched(LaunchActivatedEventArgs args)
        {
            Window.Current.Content = new MainPage();
            Window.Current.Activate();
        }

        protected override void OnActivated(IActivatedEventArgs args)
        {
            System.Diagnostics.Debug.WriteLine("OnActivated");
            base.OnActivated(args);
        }

        protected override void OnFileActivated(FileActivatedEventArgs args)
        {
            System.Diagnostics.Debug.WriteLine("OnFileActivated: {0} {1} {2} {3}", args.Files[0].Path, args.Kind, args.PreviousExecutionState, args.Verb);
            base.OnFileActivated(args);
        }

        protected override void OnFilePickerActivated(FilePickerActivatedEventArgs args)
        {
            System.Diagnostics.Debug.WriteLine("OnFilePickerActivated");
            base.OnFilePickerActivated(args);
        }



    }
}
