﻿using System;
using Petzold.Epub;
using Petzold.Epub.Common;

namespace TheNewEpublic
{
    public class BookReference
    {
        public BookReference()
        {
        }

        public BookReference(string storageFilePath, string packageFilePath, BookInformation information)
        {
            string strCreator = null;

            foreach (var creator in information.Creators)
            {
                if (strCreator != null)
                    strCreator += "\n";

                strCreator += creator.Name;

                if (!String.IsNullOrEmpty(creator.Role))
                    strCreator += String.Format(" ({0})", creator.Role);
            }

            this.FileName = storageFilePath;
            this.OpfFileName = packageFilePath;
            this.Title = information.Titles[0];
            this.Creator = strCreator;
            this.Publisher = information.Publisher;

            if (information.Dates != null && information.Dates.Length > 0)
            {
                this.Publisher += " (";

                for (int i = 0; i < information.Dates.Length; i++)
                {
                    if (i > 0)
                        this.Publisher += ", ";

                    this.Publisher += information.Dates[i].Date.Year;
                }
                this.Publisher += ")";
            }
        }

        public string FileName { set; get; }

        public string OpfFileName { set; get; }

        public string Title { set; get; }

        public string Creator { set; get; }

        public string Publisher { set; get; }

        public string Description { set; get; }

        public BookLocation Location { set; get; }
    }
}
