﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TheNewEpublic
{
    public class Library : INotifyPropertyChanged
    {
        ObservableCollection<BookReference> books;

        public event PropertyChangedEventHandler PropertyChanged;

        public Library()
        {
            Books = new ObservableCollection<BookReference>();
        }

        public ObservableCollection<BookReference> Books 
        { 
            set
            {
                if (books != value)
                {
                    books = value;
                    OnPropertyChanged("Books");
                }
            }
            get
            {
                return books;
            }
        }

        protected void OnPropertyChanged(string propertyName)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
