﻿using System;
using System.Collections.Generic;
using System.IO;
using System.IO.Compression;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Petzold.Epub;

namespace TheNewEpublic
{
    public class ZipPackageAccessor : IPackageAccessor
    {
        ZipArchive zipArchive;

        public ZipPackageAccessor(Stream stream)
        {
            zipArchive = new ZipArchive(stream, ZipArchiveMode.Read);
        }

        public string DirectoryPreface { set; get; }

        public Stream GetFile(string pathname)
        {
            ZipArchiveEntry zipArchiveEntry = zipArchive.GetEntry(pathname);

            if (zipArchiveEntry == null && !String.IsNullOrEmpty(this.DirectoryPreface))
            {
    //            System.Diagnostics.Debug.WriteLine("ZipPackageAccessor can't find {0} so trying {1}", pathname, this.DirectoryPreface + pathname);

                zipArchiveEntry = zipArchive.GetEntry(this.DirectoryPreface + pathname);
            }

            return zipArchiveEntry != null ? zipArchiveEntry.Open() : null;
        }
    }
}
